/*外部冲击下的政府间纵向财政竞争与合作*/
cd C:\Users\27660\Desktop
set more off
cap log close
use data\original.dta,clear
xtset countyid year
/*数据清理*/
replace villagepop=. if villagepop>=pop
replace pop=. if villagepop>=pop
replace ownexp=. if ownexp/ gdp>1
replace ownreve=. if ownreve/ gdp>1
replace gdp=. if ownreve/ gdp>1
replace first=. if first+second>gdp
replace second=. if first+second>gdp
replace gdp=. if first+second>gdp
replace cityfirst=. if cityfirst+citysecond>citygdp
replace citysecond=. if cityfirst+citysecond>citygdp
replace citygdp=. if cityfirst+citysecond>citygdp
winsor2 gdp ownreve ownexp general special taxreturn first second area pop villagepop bed save product townnum citygdp cityfirst citysecond cityrkmd cityreve cityexp citypop cityslope, replace cuts(1 99) trim
/*设置新变量*/
gen reve1=ownreve/gdp*100
label variable reve1 "本级收入占GDP比重"
gen exp1=ownexp/gdp*100
label variable exp1 "本级支出占GDP比重"
gen zyzf=general+special+taxreturn
label variable zyzf "转移支付总额"
gen zyzf1=zyzf/gdp*100
label variable zyzf1 "转移支付总额占GDP比重"
gen general1=general/gdp*100
label variable general1 "一般转移支付占GDP比重"
gen special1=special/gdp*100
label variable special1 "专项转移支付占GDP比重"
gen zxzb=special/zyzf*100
label variable zxzb "专项转移支付占转移支付总额比重"
gen ybzb=general/zyzf*100
label variable ybzb "一般转移支付占转移支付总额比重"
gen czzjl=ownreve/ownexp*100
label variable czzjl "财政自给率"
gen czhl=100-villagepop/pop*100
label variable czhl "城镇化率"
gen rkmd=pop/area*10000
label variable rkmd "人口密度(人/平方公里)"
gen cxbz=townnum/pop
label variable cxbz "每万人拥有乡镇数量(个)"
gen cyjg1=first/gdp*100
label variable cyjg1 "第一产业增加值占GDP比重"
gen cyjg2=second/gdp*100
label variable cyjg2 "第二产业增加值占GDP比重"
gen cxl=save/gdp*100
label variable cxl "储蓄率"
gen perbed=bed/pop
label variable perbed "人均医院床位数(张/万人)"
gen cyjg3=100-cyjg1-cyjg2
label variable cyjg3 "第三产业增加值占GDP比重"
gen realreve1=ownreve/cpi*100
label variable realreve1 "实际财政收入(万元)"
gen realexp1=ownexp/cpi*100
label variable realexp1 "实际财政支出(万元)"
gen realzyzf1=zyzf/cpi*100
label variable realzyzf1 "实际转移支付(万元)"
gen realspecial1=special/cpi*100
label variable realspecial1 "实际专项转移支付(万元)"
gen realgeneral1=general/cpi*100
label variable realgeneral1 "实际一般转移支付(万元)"
gen realgdp1=gdp/deflator
label variable realgdp1 "实际GDP(GDP平减指数)"
gen perrealgdp1=realgdp1/pop
label variable perrealgdp1 "人均实际GDP(GDP平减指数)"
gen perrealreve1=ln(realreve1/pop)
label variable perrealreve1 "人均实际财政收入"
gen perrealexp1=ln(realexp1/pop)
label variable perrealexp1 "人均实际财政支出"
gen perrealzyzf1=ln(realzyzf1/pop)
label variable perrealzyzf1 "人均实际转移支付"
gen perrealspecial1=ln(realspecial1/pop)
label variable perrealspecial1 "人均实际专项转移支付"
gen perrealgeneral1=ln(realgeneral1/pop)
label variable perrealgeneral1 "人均实际一般转移支付"
gen realgdpgr1=(realgdp1-l.realgdp1)/l.realgdp1*100
label variable realgdpgr1 "实际GDP增长率(GDP平减指数)"
gen lnperrealgdp1=ln(perrealgdp1)
label variable lnperrealgdp1 "人均实际GDP对数(GDPdef)"
gen product=ln(product1)
label variable product "规模以上工业企业产值对数"
gen rkmd1=ln(rkmd)
label variable rkmd1 "人口密度对数"
geodist latitude_ur longitude_ur latitude_cap longitude_cap,gen(distance)
label variable distance "市中心与省中心距离"
gen lncityrkmd=ln(cityrkmd)
label variable lncityrkmd "全市人口密度对数值"
gen perrealcitygdp=citygdp/deflator/citypop
label variable perrealcitygdp "全市人均实际GDP"
gen lnperrealcitygdp=ln(perrealcitygdp)
label variable lnperrealcitygdp "全市实际人均GDP对数值"
gen cityczzjl =cityreve/cityexp*100
label variable cityczzjl "市财政自给率"
gen cityfirst1=cityfirst/citygdp*100
label variable cityfirst1 "市第一产业增加值占GDP比重"
gen citysecond1=citysecond/citygdp*100
label variable citysecond1 "市第二产业增加值占GDP比重"
gen provinceczzjl=provincereve/provinceexp*100
label variable provinceczzjl "省财政自给率"
gen lnperrealprovincegdp=ln(provincegdp*10000/deflator/provincepop)
label variable lnperrealprovincegdp "全省实际人均GDP对数值"
gen provincefirst1=provincefirst/provincegdp*100
label variable provincefirst1 "全省第一产业产值占GDP比重"
gen provincesecond1=provincesecond/provincegdp*100
label variable provincesecond1 "全省第二产业产值占GDP比重"
gen lnprovincerkmd=ln(provincepop/provincearea)
label variable lnprovincerkmd "全省人口密度对数值"
replace zyzf1=. if exp1==.
gen taxreform=1 if provinceid==5 & year>=2004
replace taxreform=1 if provinceid==7 & year>=2004
replace taxreform=1 if provinceid==1 & year>=2006
replace taxreform=1 if provinceid==8 & year>=2006
replace taxreform=1 if provinceid==16 & year>=2006
replace taxreform=1 if provinceid==2 & year>=2005
replace taxreform=1 if provinceid==3 & year>=2005
replace taxreform=1 if provinceid==4 & year>=2005
replace taxreform=1 if provinceid==6 & year>=2005
replace taxreform=1 if provinceid==9 & year>=2005
replace taxreform=1 if provinceid==10 & year>=2005
replace taxreform=1 if provinceid==11 & year>=2005
replace taxreform=1 if provinceid==12 & year>=2005
replace taxreform=1 if provinceid==13 & year>=2005
replace taxreform=1 if provinceid==14 & year>=2005
replace taxreform=1 if provinceid==15 & year>=2005
replace taxreform=1 if provinceid==17 & year>=2005
replace taxreform=1 if provinceid==18 & year>=2005
replace taxreform=1 if provinceid==19 & year>=2005
replace taxreform=1 if provinceid==20 & year>=2005
replace taxreform=0 if taxreform==.
label variable taxreform "农村税费改革"
winsor2 reve1 exp1 zyzf1 special1 general1 czzjl ybzb zxzb czhl ssfc cyjg1 cyjg2 cyjg3 cxl perbed realreve1 realexp1 realzyzf1 realspecial1 realgeneral1 realgdp1 perrealgdp1 perrealreve1 perrealexp1 perrealzyzf1 perrealgeneral1 perrealspecial1 lnperrealgdp1 product rkmd1 cxbz cityfirst1 citysecond1 cityczzjl perrealcitygdp lnperrealcitygdp lncityrkmd distance, replace cuts(1 99) trim
set matsize 1200
xtset countyid year
gen pre1=treatment*(post==-1)
gen pre2=treatment*(post==-2)
gen pre3=treatment*(post==-3)
gen pre4=treatment*(post==-4)
gen pre5=treatment*(post==-5)
gen pre6=treatment*(post==-6)
gen pre7=treatment*(post==-7)
gen pre8=treatment*(post==-8)
gen pre9=treatment*(post==-9)
gen pre10=treatment*(post==-10)
gen pre11=treatment*(post==-11)
gen pre12=treatment*(post==-12)
gen post0=treatment*(post==0)
gen post1=treatment*(post==1)
gen post2=treatment*(post==2)
gen post3=treatment*(post==3)
gen post4=treatment*(post==4)
gen post5=treatment*(post==5)
gen pre5_12=pre5+pre6+pre7+pre8+pre9+pre10+pre11+pre12
gen post2_5=post2+post3+post4+post5
gen provincereform=1 if provinceid==6 & year>=2004
replace provincereform=1 if provinceid==18 & year>=2007
replace provincereform=1 if provinceid==15 & year>=2009
replace provincereform=1 if provinceid==1 & year>=2005
replace provincereform=1 if provinceid==9 & year>=2004
replace provincereform=1 if provinceid==10 & year>=2004
replace provincereform=1 if provinceid==5 & year>=2005
replace provincereform=1 if provinceid==19 & year>=2007
replace provincereform=1 if provinceid==8 & year>=2009
replace provincereform=1 if provinceid==2 & year>=2007
replace provincereform=1 if provinceid==17 & year>=2007
replace provincereform=1 if provinceid==14 & year>=2007
replace provincereform=1 if provinceid==16 & year>=2009
replace provincereform=0 if provincereform==.
gen provincetreatment=provincereform if year==2009
bys countyid: egen min=min(provincetreatment)
replace provincetreatment=min if year<=2009
drop min
bys countyid: gen provincepost=year if provincereform==1 & l.provincereform==0
bys countyid: egen min=min(provincepost)
replace provincepost=(year-min)
replace provincepost=0 if provincetreatment==0
drop min
gen iv=provincereform*distance
gen ppre1=distance*provincetreatment*(provincepost==-1)
gen ppre2=distance*provincetreatment*(provincepost==-2)
gen ppre3=distance*provincetreatment*(provincepost==-3)
gen ppre4=distance*provincetreatment*(provincepost==-4)
gen ppre5=distance*provincetreatment*(provincepost==-5)
gen ppre6=distance*provincetreatment*(provincepost==-6)
gen ppre7=distance*provincetreatment*(provincepost==-7)
gen ppre8=distance*provincetreatment*(provincepost==-8)
gen ppre9=distance*provincetreatment*(provincepost==-9)
gen ppre10=distance*provincetreatment*(provincepost==-10)
gen ppre11=distance*provincetreatment*(provincepost==-11)
gen ppre12=distance*provincetreatment*(provincepost==-12)
gen ppost0=distance*provincetreatment*(provincepost==0)
gen ppost1=distance*provincetreatment*(provincepost==1)
gen ppost2=distance*provincetreatment*(provincepost==2)
gen ppost3=distance*provincetreatment*(provincepost==3)
gen ppost4=distance*provincetreatment*(provincepost==4)
gen ppost5=distance*provincetreatment*(provincepost==5)
gen ppre5_12=ppre5+ppre6+ppre7+ppre8+ppre9+ppre10+ppre11+ppre12
gen ppost2_5=ppost2+ppost3+ppost4+ppost5
save data\basic.dta,replace
/*表1-数据描述性统计*/
asdoc sum reform perrealgdp1 czhl rkmd cxbz cyjg1 cyjg2 exp1 zyzf1 general1 special1 cxl perbed perrealcitygdp cityfirst1 citysecond1 cityczzjl cityrkmd distance
/*表2-省直管县改革效应*/
use data\basic.dta,clear
tab year,gen(dyear)
global control1 "lnperrealgdp1 cyjg1 cyjg2 cxbz czhl rkmd1 econexpand poorcounty taxreform lnperrealcitygdp cityczzjl cityfirst1 citysecond1 lncityrkmd poorcity zhiguan"
foreach v in exp1 zyzf1 ssfc{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv), fe cluster (cityid) first
outreg2 using output/IV.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
outreg2 using output/IV.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(ssfc) bdec(3) tdec(3) append
/*图2-平行趋势检验*/
use data\basic.dta,clear
tab year,gen(dyear)
foreach v in exp1 zyzf1 ssfc{
xtivreg2 `v' $control1 dyear1-dyear13 (pre5_12 pre4 pre3 pre2 post0 post1 post2_5=ppre5_12 ppre4 ppre3 ppre2 ppost0 ppost1 ppost2_5), fe cluster(cityid)
outreg2 using output\IV-平行趋势检验.xls,r2 dec(3) append ctitle(`v')
}
outreg2 using output\IV-平行趋势检验.xls,r2 dec(3) append ctitle(ssfc)
/*加入三个新控制变量后的回归结果*/
use data\basic.dta,clear
tab year,gen(dyear)
global control2 "lnperrealgdp1 cyjg1 cyjg2 cxbz czhl rkmd1 econexpand poorcounty taxreform lnperrealcitygdp cityczzjl cityfirst1 citysecond1 lncityrkmd poorcity zhiguan perbed cxl product"
foreach v in exp1 zyzf1 ssfc{
xtivreg2 `v' $control2 dyear1-dyear13 (reform=iv), fe cluster (cityid)
outreg2 using output/稳健性检验-新增控制变量.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
/*PSM-DID估计结果*/
use data\basic.dta,clear
tab year,gen(dyear)
/*control1中zhiguan变量在此回归时会被自动drop故而删去*/
global control3 "lnperrealgdp1 cyjg1 cyjg2 cxbz czhl rkmd1 econexpand poorcounty taxreform lnperrealcitygdp cityczzjl cityfirst1 citysecond1 lncityrkmd poorcity"
set seed 10101
gen tmp=runiform()
sort tmp
foreach a in exp1 zyzf1 ssfc{
psmatch2 treatment $control3, out(`a') neighbor(1) common caliper(.05) ties
pstest,both
twoway(kdensity _pscore if treatment==1,legend(label(1 "treatment group")))(kdensity _pscore if treatment==0,legend(label(2 "control group"))),xtitle (Pscore)title("Before")
graph export "output\before.png", as(png) replace
twoway(kdensity _ps if treatment==1,legend(label(1 "treatment group")))(kdensity _ps if(_weight==1),legend(label(2 "control group"))),xtitle (Pscore)title("After")
graph export "output\after.png", as(png) replace
drop if _weight==.
reg `a' reform $control3 i.countyid i.year,cluster (cityid)
outreg2 using output\PSM.xls,adjr2 dec(3) append ctitle(`a')
}
/*异质性分析-一般转移支付与专项转移支付*/
use data\basic.dta,clear
tab year,gen(dyear)
foreach v in general1 special1{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv), fe cluster (cityid) first
outreg2 using output/异质性分析-一般转移支付与专项转移支付.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
/*异质性分析-强市弱县与弱市强县*/
/*弱市强县*/
use data\basic.dta,clear
gen rate1=cityurbangdp/citygdp
replace rate1=. if rate1>1
bys countyid: gen a=rate1 if year==2001
bys countyid: egen min=min(a)
replace a=min
drop min
bys countyid: gen b=rate1 if year==2002
bys countyid: egen min=min(b)
replace b=min
drop min
gen newrate=(a+b)/2
sum newrate if treatment==1,detail
drop if treatment==1 & newrate>.2609698 
tab year,gen (dyear)
foreach v in exp1 zyzf1{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv) , fe cluster(cityid)
outreg2 using output\异质性-弱市强县.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
/*强市弱县*/
use data\basic.dta,clear
gen rate1=cityurbangdp/citygdp
replace rate1=. if rate1>1
bys countyid: gen a=rate1 if year==2001
bys countyid: egen min=min(a)
replace a=min
drop min
bys countyid: gen b=rate1 if year==2002
bys countyid: egen min=min(b)
replace b=min
drop min
gen newrate=(a+b)/2
drop if treatment==1 & newrate<.2609698 
tab year,gen (dyear)
foreach v in exp1 zyzf1{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv) , fe cluster(cityid)
outreg2 using output\异质性-强市弱县.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
/*异质性分析-政府性基金收入多少*/
/*政府性基金多*/
use data\basic.dta,clear
bys countyid: gen a=rate if year==2001
bys countyid: egen min=min(a)
replace a=min
drop min
bys countyid: gen b=rate if year==2002
bys countyid: egen min=min(b)
replace b=min
drop min
gen newrate=(a+b)/2
sum newrate if treatment==1,detail
drop if newrate<13.20543 & treatment==1
tab year,gen (dyear)
foreach v in exp1 zyzf1{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv) , fe cluster(cityid)
outreg2 using output\异质性-政府性基金收入多.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
/*土地出让少*/
use data\basic.dta,clear
bys countyid: gen a=rate if year==2001
bys countyid: egen min=min(a)
replace a=min
drop min
bys countyid: gen b=rate if year==2002
bys countyid: egen min=min(b)
replace b=min
drop min
gen newrate=(a+b)/2
sum newrate if treatment==1,detail
drop if newrate>13.20543 & treatment==1
tab year,gen (dyear)
foreach v in exp1 zyzf1{
xtivreg2 `v' $control1 dyear1-dyear13 (reform=iv) , fe cluster(cityid)
outreg2 using output\异质性-政府性基金收入少.xls,addstat(p-value of underidentification, e(idp), Weak identification K-P F statistic, e(widstat), Hansen J, e(j)) ctitle(`v') bdec(3) tdec(3) append
}
